ScriptName = Lil' Builder
RegExMatch("$LastChangedRevision: 9 $"
         . "$LastChangedDate: 2007-06-02 04:51:18 +0200 (Sa, 02 Jun 2007) $"
         , "(?P<Num>\d+).*?(?P<Date>(?:\d+-?){3})", SVN_Rev)

#NoEnv
#SingleInstance force
SetBatchLines, -1
SetControlDelay, -1 
CoordMode, Mouse, Screen 
OnExit, LilBuilder_OnExit

LilBuilder()

Return
;####################  End  of  Auto-Exec  #####################################

;Actions On Exit
LilBuilder_OnExit:
  Dock_ShutDown()
  ExitApp
Return

;external modules
#include ext\MMenu\MMenu.ahk
#include ext\Dic\Dic.ahk

;code to include
#include inc\IE.ahk              ;wrappers for controls
#Include inc\CoHelper.ahk
#include inc\Structs.ahk
#include inc\Dock.ahk
#include inc\HiEdit.ahk
#include inc\RaGrid.ahk
#include inc\HLink.ahk

;necessary function for HLink control
HLink_Notify(p1, p2, p3){
   msgbox %p1%
}

#include inc\Toolbox.ahk         ;LilBuilder code
#include inc\Gui.ahk
#include inc\Selector.ahk
#include inc\Grid.ahk
#include inc\Messages.ahk

#include inc\Menu.ahk            ;menus for standard controls
#include inc\Text.ahk
#include inc\Edit.ahk
#include inc\ComboBox.ahk
#include inc\Button.ahk
#include inc\CheckBox.ahk
#include inc\Radio.ahk
#include inc\Picture.ahk
#include inc\ListBox.ahk
#include inc\ListView.ahk
#include inc\TreeView.ahk
#include inc\Tab.ahk
#include inc\HotKey.ahk
#include inc\GroupBox.ahk
#include inc\DateTime.ahk
#include inc\MonthCal.ahk
#include inc\Progress.ahk
#include inc\UpDown.ahk
#include inc\Slider.ahk
#include inc\StatusBar.ahk

;###############################################################################
;#######        M  A  I  N       ###############################################
;###############################################################################

;main
LilBuilder(){
  LilBuilder_InitializeValues()          ;initalize some values

  LilBuilder_CreateTrayMenu()            ;create tray menu

  Selector_Create()                      ;create selector gui

  ToolBox_Create()                       ;create toolbox

  Gui_Create()                           ;create an empty gui

  LilBuilder_DockWindows()               ;dock toolbox to empty gui

  Menu_Create()                          ;create Menus

  Messages_SetHandlers( true )           ;enable message handlers

  LilBuilder_InitializeHotkeys()         ;set up hotkeys
}

;###############################################################################
;###############################################################################
;###############################################################################

LilBuilder_InitializeValues(){
  global

  ;window frame height/width of a regular gui
  SysGet, SM_CXSIZEFRAME, 32   ;width of frame
  SysGet, SM_CYSIZEFRAME, 33   ;height of frame
  SysGet, SM_CYCAPTION, 4      ;height of caption, the whole title height is: SM_CYCAPTION + SM_CYSIZEFRAME

  ;window frame height/width of a toolwindow gui
  SysGet, SM_CXFIXEDFRAME, 7   ;width of frame
  SysGet, SM_CYFIXEDFRAME, 8   ;height of frame
  SysGet, SM_CYSMCAPTION, 51   ;height of caption, the whole title height is: SM_CYSMCAPTION + SM_CYFIXEDFRAME
}

;###############################################################################

LilBuilder_CreateTrayMenu(){

}

;###############################################################################

LilBuilder_DockWindows(){
  global
  Dock_HostId   := Gui_HWND()
  Dock_ClientID := Toolbox_HWND()

  Dock(0,-1,-10, 0,0,0, 0,130, 0,665)    ;dock toolbox to left, top

  Dock_Update(Dock_HostId)               ; :D

  DisableSystemMenuCommand(Dock_HostId)     ;disable window movement
  DisableSystemMenuCommand(Dock_ClientID)

}

;###############################################################################

LilBuilder_InitializeHotkeys(){
  Selector_HWND := Selector_HWND()
  Hotkey, IfWinActive, ahk_id %Selector_HWND%
  Hotkey, DEL, Selector_OnDelete
  Hotkey, LShift, Grid_Change
  Hotkey, LAlt, Grid_Change
  Hotkey, IfWinActive
}

;###############################################################################

DisableSystemMenuCommand(hWnd = "", SystemCommand = "0xF010") {   ; SC_MOVE = 0xF010
  if !hWnd
    hWnd := WinExist("A")  ; Active window handle
  hSysMenu := DllCall("GetSystemMenu", "Int", hWnd, "Int", False)  ; Retrieve SystemMenu handle
  return DllCall("RemoveMenu", "Int", hSysMenu, "UInt", SystemCommand, "UInt", 0)  ; MF_BYCOMMAND = 0
} 
